### Enumeration

# Pango AttrType

#### Declaration

    enum Pango.AttrType

#### Description [src]

The `PangoAttrType` distinguishes between different types of attributes.

Along with the predefined values, it is possible to allocate additional values for custom attributes using `pango_attr_type_register()`. The predefined values are given below. The type of structure used to store the attribute is listed in parentheses after the description.

#### Members

Name | Description
--- | ---
`PANGO_ATTR_INVALID` | Does not happen.
`PANGO_ATTR_LANGUAGE` | Language (`PangoAttrLanguage`)
`PANGO_ATTR_FAMILY` | Font family name list (`PangoAttrString`)
`PANGO_ATTR_STYLE` | Font slant style (`PangoAttrInt`)
`PANGO_ATTR_WEIGHT` | Font weight (`PangoAttrInt`)
`PANGO_ATTR_VARIANT` | Font variant (normal or small caps) (`PangoAttrInt`)
`PANGO_ATTR_STRETCH` | Font stretch (`PangoAttrInt`)
`PANGO_ATTR_SIZE` | Font size in points scaled by `PANGO_SCALE` (`PangoAttrInt`)
`PANGO_ATTR_FONT_DESC` | Font description (`PangoAttrFontDesc`)
`PANGO_ATTR_FOREGROUND` | Foreground color (`PangoAttrColor`)
`PANGO_ATTR_BACKGROUND` | Background color (`PangoAttrColor`)
`PANGO_ATTR_UNDERLINE` | Whether the text has an underline (`PangoAttrInt`)
`PANGO_ATTR_STRIKETHROUGH` | Whether the text is struck-through (`PangoAttrInt`)
`PANGO_ATTR_RISE` | Baseline displacement (`PangoAttrInt`)
`PANGO_ATTR_SHAPE` | Shape (`PangoAttrShape`)
`PANGO_ATTR_SCALE` | Font size scale factor (`PangoAttrFloat`)
`PANGO_ATTR_FALLBACK` | Whether fallback is enabled (`PangoAttrInt`)
`PANGO_ATTR_LETTER_SPACING` | Letter spacing (`PangoAttrInt`)
`PANGO_ATTR_UNDERLINE_COLOR` | Underline color (`PangoAttrColor`)
`PANGO_ATTR_STRIKETHROUGH_COLOR` | Strikethrough color (`PangoAttrColor`)
`PANGO_ATTR_ABSOLUTE_SIZE` | Font size in pixels scaled by `PANGO_SCALE` (`PangoAttrInt`)
`PANGO_ATTR_GRAVITY` | Base text gravity (`PangoAttrInt`)
`PANGO_ATTR_GRAVITY_HINT` | Gravity hint (`PangoAttrInt`)
`PANGO_ATTR_FONT_FEATURES` | OpenType font features (`PangoAttrFontFeatures`). Since 1.38
`PANGO_ATTR_FOREGROUND_ALPHA` | Foreground alpha (`PangoAttrInt`). Since 1.38
`PANGO_ATTR_BACKGROUND_ALPHA` | Background alpha (`PangoAttrInt`). Since 1.38
`PANGO_ATTR_ALLOW_BREAKS` | Whether breaks are allowed (`PangoAttrInt`). Since 1.44
`PANGO_ATTR_SHOW` | How to render invisible characters (`PangoAttrInt`). Since 1.44
`PANGO_ATTR_INSERT_HYPHENS` | Whether to insert hyphens at intra-word line breaks (`PangoAttrInt`). Since 1.44
`PANGO_ATTR_OVERLINE` | Whether the text has an overline (`PangoAttrInt`). Since 1.46
`PANGO_ATTR_OVERLINE_COLOR` | Overline color (`PangoAttrColor`). Since 1.46
`PANGO_ATTR_LINE_HEIGHT` | Line height factor (`PangoAttrFloat`). Since: 1.50
`PANGO_ATTR_ABSOLUTE_LINE_HEIGHT` | Line height (`PangoAttrInt`). Since: 1.50
`PANGO_ATTR_TEXT_TRANSFORM` | No description available.
`PANGO_ATTR_WORD` | Override segmentation to classify the range of the attribute as a single word (`PangoAttrInt`). Since 1.50
`PANGO_ATTR_SENTENCE` | Override segmentation to classify the range of the attribute as a single sentence (`PangoAttrInt`). Since 1.50
`PANGO_ATTR_BASELINE_SHIFT` | Baseline displacement (`PangoAttrInt`). Since 1.50
`PANGO_ATTR_FONT_SCALE` | Font-relative size change (`PangoAttrInt`). Since 1.50

#### Type functions

###### pango_attr_type_get_name

Fetches the attribute type name.

Available since: 1.22

###### pango_attr_type_register

Allocate a new attribute type ID.